<template>
  <div class="row">
    <div
      v-for="n in (data.length > 3 ? 2 : 1)"
      :key="n"
      class="col-sm-6"
    >
      <div
        v-for="(section, i) in (data.length > 3 ? (n === 1 ? data.slice(0, 3) : data.slice(3, 5)) : data)"
        :key="i"
        class="section"
      >
        <SubTitle v-if="section.title">
          {{ section.title }}
        </SubTitle>

        <div
          v-for="(checkbox, j) in section.items"
          class="checkbox-group"
          :key="j"
        >
          <ObCheckbox
            v-model="checkbox.isSelected"
            :label="checkbox.title"
            :required="checkbox.isRequired"
            :disabled="checkbox.isRequired || checkbox.isDisabled"
            :data-key="checkbox.key"
            :ref="referer"
            :data-qa="dataQa+'_chb_' + i + '_' + j"
            class="checkbox"
            @change="onCheckboxChange(checkbox)"
          />

          <ObTooltip
            v-if="checkbox.tooltip"
            :content="checkbox.tooltip"
            position="top-start"
            class="tooltip"
          >
            <i class="icon question" />
          </ObTooltip>

          <div
            v-if="checkbox.description"
            v-text="checkbox.description"
            class="description"
          />
        </div>
      </div>
    </div>
  </div>
</template>

<script>
  import ObCheckbox from 'common-components/src/obComponents/obCheckbox'
  import ObTooltip from 'common-components/src/obComponents/obTooltip'
  import SubTitle from '../components/SubTitle'

  export default {
    name: 'TableSection',
    components: {
      ObCheckbox,
      ObTooltip,
      SubTitle
    },
    props: {
      referer: {
        type: String,
        default: ''
      },
      data: {
        type: Array,
        default: () => []
      },
      dataQa: {
        type: String
      }
    },
    watch: {
      data () {
        // Call this method in 'watch', because
        // we need to handle cases, when user changing
        // checkboxes and reopen modal window.
        // And when user reopened it, mounted()
        // method will not call already.
        this.calcCheckboxesCount()
      }
    },
    mounted () {
      this.calcCheckboxesCount()
    },
    methods: {
      onCheckboxChange (checkbox) {
        this.calcCheckboxesCount()

        this.$emit('onCheckboxChange', checkbox)
      },
      calcCheckboxesCount () {
        this.$emit('calcCheckboxesCount', {
          sectionReferer: this.referer,
          total: this.$refs[this.referer].length,
          selected: this.data.reduce((sum, section) => {
            return sum + section.items.filter((checkbox) => {
              return checkbox.isSelected
            }).length
          }, 0)
        })
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import '~common-components/src/static/css/variables';
  @import '~common-components/src/static/css/mixins';

  .checkbox-group {
    display: flex;
    flex-wrap: wrap;
    align-items: center;
    margin-bottom: 10px;

    &.last {
      margin-bottom: 30px;
    }
  }

  .checkbox:not(:last-child) {
    margin-right: 6px;
  }

  .tooltip {
    color: $color-blue-navy-blue;
    font-size: 12px;
  }

  .section:not(:last-child) {
    margin-bottom: 30px;
  }

  .description {
    @include font-mixin(12px, 16px, normal, $color-grey-label);

    flex-basis: 100%;
    margin: 10px 0 0 30px;
    max-width: 300px;
  }
</style>